<script lang="ts">
  import type { TimeT } from "./Time.svelte";
  import type { Error as ErrorT } from "./Error.svelte";

  import Time from "./Time.svelte";
  import Error from "./Error.svelte";

  export let errors: Array<[TimeT, ErrorT]> = [];

  let open = false;
</script>

<div id="error">
  <h3
    on:click={() => (open = !open)}
    on:keypress={() => (open = !open)}
    role="button"
    tabindex="0"
  >
    Errors
  </h3>
  <hr class:open />
  <div class="errorContent" class:open>
    {#each errors as error}
      <div style="display:flex">
        <div style="margin-right: 5px">
          <Time time={error[0]} />
        </div>
        <div>
          <Error error={error[1]} />
        </div>
      </div>
    {/each}
  </div>
</div>

<style lang="sass">
	#error
		z-index: 9
		background-color: #121212
		color: #ff1744
		position: fixed
		bottom: 0
		left: 0
		right: 0

		h3
			padding: 15px
			margin: 0
			cursor: pointer

		hr
			display: none
			&.open
				display: inherit

		.errorContent
			&.open
				height: 500px
				margin: 16px

			transition: height .6s cubic-bezier(0, 1, .7, 1)

			height: 0
			max-height: calc( 100vh - 95px )

			margin-right: 0

			font-family: monospace
			font-size: 17px
			text-align: left

			overflow-y: scroll
</style>
